#include "ShaderConstants.fxh"

struct VS_Input
{
    float3 position : POSITION;
    float4 color : COLOR;
#ifdef INSTANCEDSTEREO
	uint instanceID : SV_InstanceID;
#endif
};


struct PS_Input
{
    float4 position : SV_Position;
    float4 color : COLOR;
#ifdef INSTANCEDSTEREO
	uint instanceID : SV_InstanceID;
#endif
};


void main( in VS_Input VSInput, out PS_Input PSInput )
{
#ifdef INSTANCEDSTEREO
	int i = VSInput.instanceID;
	PSInput.position = mul( WORLDVIEWPROJ_STEREO[i], float4( VSInput.position, 1 ) );
	PSInput.instanceID = i;
#else
	PSInput.position = mul(WORLDVIEWPROJ, float4(VSInput.position, 1));
#endif
    PSInput.color = lerp( CURRENT_COLOR, FOG_COLOR, VSInput.color.r );

	float4 sky = CURRENT_COLOR;
	float4 fog = FOG_COLOR;
	float4 c = COLOR;
	float fog_flag = 0.0;

	float3 cD = float3(0.5,0.5,0.55);
	float3 rD = float3(1.5);
	float3 cN = float3(0.25, 0.6, 0.8) * 0.125;

	if(FOG_CONTROL.x < 0.55 && FOG_CONTROL.x > 0.1){
	fog_flag = 1.0;
	sky.rgb = max(sky.rgb * rD, cN);
	color = mix(sky, fog, c.r);
	}

	sky.rgb = max(sky.rgb * cD, cN);
	if(fog.r > 0.15 && fog.g > 0.15){
	fog.rgb = max(fog.rgb * 3.0, 0.0);}
	if(fog.r < 0.15 && fog.g < 0.15){
	fog.rgb = max(fog.rgb * 1.0, 0.0);}

	if(fog_flag == 0.0){
	color = mix(sky, fog, c.r);}
}